$regfile = "xm256a3def.dat"
$crystal = 2000000
$hwstack = 256
$swstack = 512
$framesize = 512
$loader = &H20000
$lib "xmega.lib" : $external _xmegafix_clear : $external _xmegafix_rol_r1014
$map

Config Sysclock = 2mhz , Prescalea = 1 , Prescalebc = 1_1   'use the 2MHz startup sysclock

Disable Interrupts                                          'we do not use ints

'---------------- Config part -------------------------------
Const Maxwordbit = 7
Const Maxword =(2 ^ Maxwordbit) * 2
Const Maxwordshift = Maxwordbit + 1
Const Loadsize = &H1EFFF * 2                                'xmega256 application flash in words * 2
Const Filenamebin = "Master.bin"                            'Filename of the file to load
'Const Filenamebindone = "M.Bin"                             'Should the file be renamed after flashing?
Const Lcdoutput = 1                                         'Want to use LCD Output? Code is for loading Bargraph on T6963 240*64
Const Encrypted = 1                                         'Want to load AES-Encrypted Bin-Files?
Const Keyvariation = 0                                      '0=array loaded every single byte ; 1=data at end of file
Const Lockbits = 1                                          'Want the lockbits to be modified?
Const Lockbyte = &H14                                       'Value of lockbyte
Const Checklockbits1_0 = 1                                  'check for external read/write is disabled
Const Checkjtagdisabled = 1                                 'check for jtag is disabled
'---------------- Config part -------------------------------

#if Checkjtagdisabled = 1
Const Function_read_fuses = 1
#else
Const Function_read_fuses = 0
#endif

#if Lockbits = 1
Const Sub_write_lockbits = 1                                'Want to write lockbits?
#else
Const Sub_write_lockbits = 0                                'Want to write lockbits?
#endif

#if Function_read_fuses = 1
Declare Function Read_fuses(byval Fuse_address As Byte)as Byte
#endif

#if Sub_write_lockbits = 1
Declare Sub Write_lockbits(byval Lockbyte As Byte)
#endif

#if Lcdoutput = 1
   Dim Loopcounter As Word
   Dim Linecounter As Byte
   Display_controlport Alias Porte                          'PORTE.2 - PORTE.7
   Display_dataport Alias Portf                             'PORTF.0 - PORTF.7

   Config Graphlcd = 240 * 64 , Dataport = Display_dataport , Controlport = Display_controlport , Ce = 4 , Cd = 5 , Wr = 2 , Rd = 3 , Reset = 6 , Fs = 7 , Mode = 8
   Cursor Off
#endif

Dim Btemp1 As Byte
Dim Strname1 As String * 12
#if Varexist( "FileNameBinDone")
Dim Strname2 As String * 12
#endif
Dim J As Byte , Spmcrval As Byte                            ' self program command byte value
Dim Z As Long                                               'this is the Z pointer word
Dim Vl As Byte , Vh As Byte                                 ' these bytes are used for the data values
Dim Wrd As Word , Page As Word                              'these vars contain the page and word address
Dim Buf(128) As Byte
Dim Lfilelen As Long
Dim Initfilesystemerror As Byte
Dim W1 As Word , B1 As Byte

#if Encrypted = 1
Dim Key(16) As Byte
#endif

#if Encrypted = 1 And Keyvariation = 1
Restore Keydata
For J = 1 To 16                                             ' load a key to memory
   Read Key(j)
Next
#endif

#if Encrypted = 1 And Keyvariation = 0
'Key(1) = &H00 : Key(2) = &H01 : Key(3) = &H02 : Key(4) = &H03
'Key(5) = &H04 : Key(6) = &H05 : Key(7) = &H06 : Key(8) = &H07
'Key(9) = &H08 : Key(10) = &H09 : Key(11) = &H0A : Key(12) = &H0B
'Key(13) = &H0C : Key(14) = &H0D : Key(15) = &H0E : Key(16) = &H0F
$include "key.inc"
Key(1) = Key_1 : Key(2) = Key_2 : Key(3) = Key_3 : Key(4) = Key_4
Key(5) = Key_5 : Key(6) = Key_6 : Key(7) = Key_7 : Key(8) = Key_8
Key(9) = Key_9 : Key(10) = Key_10 : Key(11) = Key_11 : Key(12) = Key_12
Key(13) = Key_13 : Key(14) = Key_14 : Key(15) = Key_15 : Key(16) = Key_16

#endif

'(
' TWI (I2C) for external High side switch
Dim Twi_start As Byte                                       'This Variable is used by the I2C functions
Open "TWIE" For Binary As #2                                'Pull-Up resistor (4K7) on SDA and SCL to Vcc = 3,3V
Config Twie = 40000                                         'Set TWI Baud Rate and Enable TWI Master
I2cinit #2                                                  'set i2c pins to right state , open collector , pull up activated
')
#if Checklockbits1_0 = 1 And Lcdoutput = 0
If Nvm_lockbits.0 = 1 Or Nvm_lockbits.1 = 1 Then Stop
#endif
#if Checklockbits1_0 = 1 And Lcdoutput = 1
If Nvm_lockbits.0 = 1 Or Nvm_lockbits.1 = 1 Then
Cls
Locate 1 , 1
Lcd "Lockbits fehlerhaft"
Stop
End If
#endif

#if Checkjtagdisabled = 1 And Lcdoutput = 0
Btemp1 = Read_fuses(4)
If Btemp1.0 = 0 Then Stop
#endif
#if Checkjtagdisabled = 1 And Lcdoutput = 1
Btemp1 = Read_fuses(4)
If Btemp1.0 = 0 Then
Cls
Locate 1 , 1
Lcd "JTAG eingeschalten"
Stop
End If
#endif

#if Lockbits = 1
If Nvm_lockbits <> Lockbyte Then
   Write_lockbits Lockbyte
End If
#endif

'(
Cls
Locate 1 , 1
Dim Hexstring As String * 2
Lcd "Fusebytes: " ;
For J = 0 To 5
If J = 3 Then Incr J                                        'there is no fusebyte3
   Hexstring = Hex(read_fuses(j))
   Lcd " " ; Hexstring
Next J
Wait 3
Locate 2 , 1
Lcd "Lockbits: " ; Hex(read_lockbits())
Wait 3
If Read_lockbits() <> &HDF Then
   Write_lockbits &HDF
End If
')
$include "Config_MMC.bas"

If Gbdriveerror <> 0 Then
#if Lcdoutput = 1
   Cls
   Locate 1 , 1
   Lcd "SD-Karte fehlerhaft"
   Wait 3
#endif
   Goto Startmain
End If

$include "CONFIG_AVR-DOS.bas"

Btemp1 = Initfilesystem(1)                                  ' Get File system
                                                    ' use 0 for drive without Master boot record
If Btemp1 <> 0 Then
#if Lcdoutput = 1
   Cls
   Locate 1 , 1
   Lcd "Dateisystem fehlerhaft"
   Wait 3
#endif
   Goto Startmain
End If



'(encrypt test
Lfilelen = Filelen( "xmega.bin")

If Lfilelen > 0 Then
   Locate 1 , 1
   Lcd "enc"
   Wait 3
   Open "xmega.bin" For Binary As #1
   Lfilelen = Filelen( "master.bin")
   If Lfilelen > 0 Then Kill "master.bin"
   Open "master.bin" For Binary As #2
   Do
      Get #1 , Buf(1) , , 128
      Aesencrypt Key(1) , Buf(1) , 128
      Put #2 , Buf(1) , , 128
         If Eof(#1) > 0 Then
            Put #2 , Buf(1) , , 128
            Close #1
            Close #2
            Kill "xmega.bin"
            Exit Do
         End If
   Loop
   Locate 1 , 1
   Lcd "rdy"
   Wait 3
End If
')

Lfilelen = Filelen(filenamebin)
If Lfilelen > 0 And Lfilelen < Loadsize Then
#if Lcdoutput = 1
   Cls
   Locate 1 , 1
   Lcd "Softwareaktualisierung"
   Locate 2 , 1
   Lcd "wird geladen - Bitte warten..."
   Wait 1
#endif
   Gosub Flashbin                                           ' Size OK
End If

#if Lcdoutput = 1
If Lfilelen > Loadsize Then
   Cls
   Locate 1 , 1
   Lcd "Aktualisierungsdatei fehlerhaft"
   Wait 5
End If
#endif

'--- Jump to mainprogram -------------------------------------------------------
Startmain:
   Rampz = 0
   Goto _reset
End



'--- Subroutines - -------------------------------------------------------------
'--- BIN-File Part -------------------------------------------------------------
Flashbin:


Open Filenamebin For Binary As #1

If Gbdoserror > 0 Then
   #if Lcdoutput = 1
      Cls
      Locate 1 , 1
      Lcd "Fehler beim oeffnen der Datei"
      Wait 3
   #endif
   Goto Startmain
End If


Page = 0
Wrd = 0

Spmcrval = &H20 : Gosub Do_spm                              ' erase  all app pages

#if Lcdoutput = 1
   Locate 3 , 1
   Box(20 , 20) -(220 , 30) , 255
   Linecounter = 20
   Loopcounter = 0
#endif


Do

   #if Encrypted = 1
      Get #1 , Buf(1) , , 128
      Aesdecrypt Key(1) , Buf(1) , 128
   #else
      Get #1 , Buf(1) , , 128
   #endif

   #if Lcdoutput = 1
   Incr Loopcounter
   If Loopcounter >= 10 Then
      Loopcounter = 0
      Incr Linecounter
      Waitms 20
      Line(linecounter , 21) -(linecounter , 29) , 255
   End If
   #endif
   Gosub Writepage
   If Eof(#1) > 0 Then
      If Wrd > 0 Then                                       'if there was something left in the page
         Wrd = 0                                            'Z pointer needs wrd to be 0
         Spmcrval = &H24 : Gosub Do_spm                     'write page
      End If
      Close #1
      #if Varexist( "FileNameBinDone")
         Strname1 = Filenamebin
         Strname2 = Filenamebindone
         Kill Strname2
         Name Strname1 As Strname2
      #else
         Kill Filenamebin
      #endif

      #if Lcdoutput = 1
         Do
            Incr Linecounter
            Line(linecounter , 21) -(linecounter , 29) , 255
            Waitms 20
         Loop Until Linecounter = 220

         Locate 2 , 1
         Lcd "erfolgreich                   "
         Wait 5
      #endif
      Exit Do
   End If
Loop
Return
'--- Ende BIN-File Part --------------------------------------------------------

'--- Programming Part ----------------------------------------------------------
'write one or more pages
Writepage:
   For J = 1 To 128 Step 2                                  'we write 2 bytes into a page
      Vl = Buf(j) : Vh = Buf(j + 1)                         'get Low and High bytes
      lds r0, {vl}                                          'store them into r0 and r1 registers
      lds r1, {vh}
      Spmcrval = &H23 : Gosub Do_spm                        'write value into page at word address
      Wrd = Wrd + 2                                         ' word address increases with 2 because LS bit of Z is not used
      If Wrd = Maxword Then                                 ' page is full
          Wrd = 0                                           'Z pointer needs wrd to be 0
          Spmcrval = &H24 : Gosub Do_spm                    'write page
          Page = Page + 1                                   'next page
      End If
   Next
Return


Do_spm:
  Z = Page                                                  'make equal to page
  Shift Z , Left , Maxwordshift                             'shift to proper place
  Z = Z + Wrd                                               'add word
  lds r30,{Z}
  lds r31,{Z+1}

  #if _romsize > 65536
      lds r24,{Z+2}
      sts rampz,r24                                         ' we need to set rampz also for the M128
  #endif

  Nvm_cmd = Spmcrval
  Cpu_ccp = &H9D
  spm                                                       'this is an asm instruction
Do_spm_busy:
   lds r23, NVM_STATUS
   sbrc r23,7                                               'if  busy bit is cleared  skip next instruc tion
   rjmp do_spm_busy
Return



'--- Ende Programming Part -----------------------------------------------------

#if Function_read_fuses = 1
Function Read_fuses(byval Fuse_address As Byte)as Byte
Nvm_addr0 = Fuse_address                                    'load Addressbyte 0
Nvm_addr1 = 0                                               'load Addressbyte 1
Nvm_addr2 = 0                                               'load Addressbyte 2
Nvm_cmd = &H07                                              'Read fuse byte at index ADDR0 into DATA0
Cpu_ccp = &HD8                                              '0xD8 IOREG Protected IO register (this disables interrupts for 4 cycles)
Nvm_ctrla.0 = 1                                             'Non-Volatile Memory Command Execute
Bitwait Nvm_status.7 , Reset                                'wait till bit is 0
Read_fuses = Nvm_data0
Nvm_cmd = 0
End Function
#endif

#if Sub_write_lockbits = 1
Sub Write_lockbits(lockbyte As Byte)
Nvm_data0 = Lockbyte
Nvm_data1 = 0
Nvm_data2 = 0
Nvm_cmd = &H08                                              'Load the NVM CMD register with the Write Lock Bit command
Cpu_ccp = &HD8                                              '0xD8 IOREG Protected IO register (this disables interrupts for 4 cycles)
Nvm_ctrla.0 = 1                                             'Non-Volatile Memory Command Execute
Bitwait Nvm_status.7 , Reset                                'wait till bit is 0
Nvm_cmd = 0
End Sub
#endif

'variation of code - using data
#if Encrypted = 1 And Keyvariation = 1
Keydata:
Data &H01 , &H02 , &H03 , &H04 , &H05 , &H06 , &H07 , &H08 , &H09 , &H0A , &H0B , &H0C , &H0D , &H0E , &H0F , &H10
#endif